The data object for a due date rule update request. The id must match the rule_id path parameter.
attributes [required]
object
Attributes for creating or updating a due date rule.
action [required]
object
The action to take when the due date rule matches a finding.
due_days_per_severity [required]
[object]
A list of severity-to-due-date mappings. Each severity may appear at most once.
due_in_days [required]
int64
The number of days from the reference point until the finding is due.
severity [required]
enum
A severity level used to configure due date thresholds.
Allowed enum values: critical,high,medium,low,info,none,unknown
due_from [required]
enum
The reference point from which the due date is calculated. When fix_available is selected but not applicable to the finding type, first_seen is used instead.
Allowed enum values: first_seen,fix_available
reason_description
string
An optional description providing more context for the due date assignment.
enabled
boolean
Whether the due date rule is enabled.
name [required]
string
The name of the due date rule.
rule [required]
object
Defines the scope of findings to which the automation rule applies.
finding_types [required]
[string]
The list of security finding types that the automation rule applies to.
query
string
A search query to further filter the findings matched by this rule. The @workflow.* namespace and @status fields are not permitted. For a reference of available fields, see the Security Findings schema documentation.
id [required]
uuid
The ID of the due date rule to update.
type [required]
enum
The JSON:API type for due date rules.
Allowed enum values: due_date_rules
The data object for a due date rule returned by the API.
attributes [required]
object
Attributes of a due date rule returned by the API.
action [required]
object
The action to take when the due date rule matches a finding.
due_days_per_severity [required]
[object]
A list of severity-to-due-date mappings. Each severity may appear at most once.
due_in_days [required]
int64
The number of days from the reference point until the finding is due.
severity [required]
enum
A severity level used to configure due date thresholds.
Allowed enum values: critical,high,medium,low,info,none,unknown
due_from [required]
enum
The reference point from which the due date is calculated. When fix_available is selected but not applicable to the finding type, first_seen is used instead.
Allowed enum values: first_seen,fix_available
reason_description
string
An optional description providing more context for the due date assignment.
created_at [required]
int64
The Unix timestamp in milliseconds when the rule was created.
created_by [required]
object
The user or Datadog system who created the rule.
id [required]
string
The actor's identifier (a user UUID or a system identifier).
name [required]
string
The name of the actor.
type [required]
enum
Whether the actor is a user or the Datadog system.
Allowed enum values: user,system
enabled [required]
boolean
Whether the due date rule is enabled.
modified_at [required]
int64
The Unix timestamp in milliseconds when the rule was last modified.
modified_by [required]
object
The user or Datadog system who last modified the rule.
id [required]
string
The actor's identifier (a user UUID or a system identifier).
name [required]
string
The name of the actor.
type [required]
enum
Whether the actor is a user or the Datadog system.
Allowed enum values: user,system
name [required]
string
The name of the due date rule.
rule [required]
object
Defines the scope of findings to which the automation rule applies.
finding_types [required]
[string]
The list of security finding types that the automation rule applies to.
query
string
A search query to further filter the findings matched by this rule. The @workflow.* namespace and @status fields are not permitted. For a reference of available fields, see the Security Findings schema documentation.
id [required]
uuid
The ID of the due date rule.
type [required]
enum
The JSON:API type for due date rules.
Allowed enum values: due_date_rules
{"data":{"attributes":{"action":{"due_days_per_severity":[{"due_in_days":7,"severity":"critical"}],"due_from":"first_seen","reason_description":"Applied for production findings only"},"created_at":1722439510282,"created_by":{"id":"00000000-0000-0000-0000-000000000000","name":"Jane Doe","type":"user"},"enabled":true,"modified_at":1722439510282,"modified_by":{"id":"00000000-0000-0000-0000-000000000000","name":"Jane Doe","type":"user"},"name":"Critical findings due in 7 days","rule":{"finding_types":["misconfiguration"],"query":"env:prod team:platform"}},"id":"00000000-0000-0000-0000-000000000000","type":"due_date_rules"}}
## default
#
# Path parameters exportrule_id="00000000-0000-0000-0000-000000000000" # Use a Personal Access Token or Service Access Token exportDD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"
// Update a due date rule returns "Successfully updated the due date rule" responsepackagemainimport("context""encoding/json""fmt""os""github.com/DataDog/datadog-api-client-go/v2/api/datadog""github.com/DataDog/datadog-api-client-go/v2/api/datadogV2""github.com/google/uuid")funcmain(){// there is a valid "valid_due_date_rule" in the systemValidDueDateRuleDataID:=uuid.MustParse(os.Getenv("VALID_DUE_DATE_RULE_DATA_ID"))body:=datadogV2.DueDateRuleUpdateRequest{Data:datadogV2.DueDateRuleDataCreate{Attributes:datadogV2.DueDateRuleAttributesCreate{Action:datadogV2.DueDateRuleAction{DueDaysPerSeverity:[]datadogV2.DueDatePerSeverityItem{{DueInDays:14,Severity:datadogV2.DUEDATESEVERITY_CRITICAL,},},DueFrom:datadogV2.DUEDATEFROM_FIRST_SEEN,},Enabled:datadog.PtrBool(false),Name:"Example-Security-Monitoring",Rule:datadogV2.AutomationRuleScope{FindingTypes:[]datadogV2.SecurityFindingType{datadogV2.SECURITYFINDINGTYPE_MISCONFIGURATION,},Query:datadog.PtrString("env:staging"),},},Type:datadogV2.DUEDATERULETYPE_DUE_DATE_RULES,},}ctx:=datadog.NewDefaultContext(context.Background())ctx=context.WithValue(ctx,datadog.ContextAccessToken,os.Getenv("DD_BEARER_TOKEN"))configuration:=datadog.NewConfiguration()configuration.SetUnstableOperationEnabled("v2.UpdateSecurityFindingsAutomationDueDateRule",true)apiClient:=datadog.NewAPIClient(configuration)api:=datadogV2.NewSecurityMonitoringApi(apiClient)resp,r,err:=api.UpdateSecurityFindingsAutomationDueDateRule(ctx,ValidDueDateRuleDataID,body)iferr!=nil{fmt.Fprintf(os.Stderr,"Error when calling `SecurityMonitoringApi.UpdateSecurityFindingsAutomationDueDateRule`: %v\n",err)fmt.Fprintf(os.Stderr,"Full HTTP response: %v\n",r)}responseContent,_:=json.MarshalIndent(resp,""," ")fmt.Fprintf(os.Stdout,"Response from `SecurityMonitoringApi.UpdateSecurityFindingsAutomationDueDateRule`:\n%s\n",responseContent)}
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com"DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"go run"main.go"
// Update a due date rule returns "Successfully updated the due date rule" responseimportcom.datadog.api.client.ApiClient;importcom.datadog.api.client.ApiException;importcom.datadog.api.client.v2.api.SecurityMonitoringApi;importcom.datadog.api.client.v2.model.AutomationRuleScope;importcom.datadog.api.client.v2.model.DueDateFrom;importcom.datadog.api.client.v2.model.DueDatePerSeverityItem;importcom.datadog.api.client.v2.model.DueDateRuleAction;importcom.datadog.api.client.v2.model.DueDateRuleAttributesCreate;importcom.datadog.api.client.v2.model.DueDateRuleDataCreate;importcom.datadog.api.client.v2.model.DueDateRuleResponse;importcom.datadog.api.client.v2.model.DueDateRuleType;importcom.datadog.api.client.v2.model.DueDateRuleUpdateRequest;importcom.datadog.api.client.v2.model.DueDateSeverity;importcom.datadog.api.client.v2.model.SecurityFindingType;importjava.util.Collections;importjava.util.UUID;publicclassExample{publicstaticvoidmain(String[]args){ApiClientdefaultClient=ApiClient.getDefaultApiClient();defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));defaultClient.setUnstableOperationEnabled("v2.updateSecurityFindingsAutomationDueDateRule",true);SecurityMonitoringApiapiInstance=newSecurityMonitoringApi(defaultClient);// there is a valid "valid_due_date_rule" in the systemUUIDVALID_DUE_DATE_RULE_DATA_ID=null;try{VALID_DUE_DATE_RULE_DATA_ID=UUID.fromString(System.getenv("VALID_DUE_DATE_RULE_DATA_ID"));}catch(IllegalArgumentExceptione){System.err.println("Error parsing UUID: "+e.getMessage());}DueDateRuleUpdateRequestbody=newDueDateRuleUpdateRequest().data(newDueDateRuleDataCreate().attributes(newDueDateRuleAttributesCreate().action(newDueDateRuleAction().dueDaysPerSeverity(Collections.singletonList(newDueDatePerSeverityItem().dueInDays(14L).severity(DueDateSeverity.CRITICAL))).dueFrom(DueDateFrom.FIRST_SEEN)).enabled(false).name("Example-Security-Monitoring").rule(newAutomationRuleScope().findingTypes(Collections.singletonList(SecurityFindingType.MISCONFIGURATION)).query("env:staging"))).type(DueDateRuleType.DUE_DATE_RULES));try{DueDateRuleResponseresult=apiInstance.updateSecurityFindingsAutomationDueDateRule(VALID_DUE_DATE_RULE_DATA_ID,body);System.out.println(result);}catch(ApiExceptione){System.err.println("Exception when calling"+" SecurityMonitoringApi#updateSecurityFindingsAutomationDueDateRule");System.err.println("Status code: "+e.getCode());System.err.println("Reason: "+e.getResponseBody());System.err.println("Response headers: "+e.getResponseHeaders());e.printStackTrace();}}}
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com"DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"java"Example.java"
"""
Update a due date rule returns "Successfully updated the due date rule" response
"""fromosimportenvironfromdatadog_api_clientimportApiClient,Configurationfromdatadog_api_client.v2.api.security_monitoring_apiimportSecurityMonitoringApifromdatadog_api_client.v2.model.automation_rule_scopeimportAutomationRuleScopefromdatadog_api_client.v2.model.due_date_fromimportDueDateFromfromdatadog_api_client.v2.model.due_date_per_severity_itemimportDueDatePerSeverityItemfromdatadog_api_client.v2.model.due_date_rule_actionimportDueDateRuleActionfromdatadog_api_client.v2.model.due_date_rule_attributes_createimportDueDateRuleAttributesCreatefromdatadog_api_client.v2.model.due_date_rule_data_createimportDueDateRuleDataCreatefromdatadog_api_client.v2.model.due_date_rule_typeimportDueDateRuleTypefromdatadog_api_client.v2.model.due_date_rule_update_requestimportDueDateRuleUpdateRequestfromdatadog_api_client.v2.model.due_date_severityimportDueDateSeverityfromdatadog_api_client.v2.model.security_finding_typeimportSecurityFindingType# there is a valid "valid_due_date_rule" in the systemVALID_DUE_DATE_RULE_DATA_ID=environ["VALID_DUE_DATE_RULE_DATA_ID"]body=DueDateRuleUpdateRequest(data=DueDateRuleDataCreate(attributes=DueDateRuleAttributesCreate(action=DueDateRuleAction(due_days_per_severity=[DueDatePerSeverityItem(due_in_days=14,severity=DueDateSeverity.CRITICAL,),],due_from=DueDateFrom.FIRST_SEEN,),enabled=False,name="Example-Security-Monitoring",rule=AutomationRuleScope(finding_types=[SecurityFindingType.MISCONFIGURATION,],query="env:staging",),),type=DueDateRuleType.DUE_DATE_RULES,),)configuration=Configuration()configuration.access_token=environ["DD_BEARER_TOKEN"]configuration.unstable_operations["update_security_findings_automation_due_date_rule"]=TruewithApiClient(configuration)asapi_client:api_instance=SecurityMonitoringApi(api_client)response=api_instance.update_security_findings_automation_due_date_rule(rule_id=VALID_DUE_DATE_RULE_DATA_ID,body=body)print(response)
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com"DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"python3"example.py"
# Update a due date rule returns "Successfully updated the due date rule" responserequire"datadog_api_client"DatadogAPIClient.configuredo|config|config.access_token=ENV["DD_BEARER_TOKEN"]config.unstable_operations["v2.update_security_findings_automation_due_date_rule".to_sym]=trueendapi_instance=DatadogAPIClient::V2::SecurityMonitoringAPI.new# there is a valid "valid_due_date_rule" in the systemVALID_DUE_DATE_RULE_DATA_ID=ENV["VALID_DUE_DATE_RULE_DATA_ID"]body=DatadogAPIClient::V2::DueDateRuleUpdateRequest.new({data:DatadogAPIClient::V2::DueDateRuleDataCreate.new({attributes:DatadogAPIClient::V2::DueDateRuleAttributesCreate.new({action:DatadogAPIClient::V2::DueDateRuleAction.new({due_days_per_severity:[DatadogAPIClient::V2::DueDatePerSeverityItem.new({due_in_days:14,severity:DatadogAPIClient::V2::DueDateSeverity::CRITICAL,}),],due_from:DatadogAPIClient::V2::DueDateFrom::FIRST_SEEN,}),enabled:false,name:"Example-Security-Monitoring",rule:DatadogAPIClient::V2::AutomationRuleScope.new({finding_types:[DatadogAPIClient::V2::SecurityFindingType::MISCONFIGURATION,],query:"env:staging",}),}),type:DatadogAPIClient::V2::DueDateRuleType::DUE_DATE_RULES,}),})papi_instance.update_security_findings_automation_due_date_rule(VALID_DUE_DATE_RULE_DATA_ID,body)
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com"DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"rb"example.rb"
// Update a due date rule returns "Successfully updated the due date rule" response
usedatadog_api_client::datadog;usedatadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;usedatadog_api_client::datadogV2::model::AutomationRuleScope;usedatadog_api_client::datadogV2::model::DueDateFrom;usedatadog_api_client::datadogV2::model::DueDatePerSeverityItem;usedatadog_api_client::datadogV2::model::DueDateRuleAction;usedatadog_api_client::datadogV2::model::DueDateRuleAttributesCreate;usedatadog_api_client::datadogV2::model::DueDateRuleDataCreate;usedatadog_api_client::datadogV2::model::DueDateRuleType;usedatadog_api_client::datadogV2::model::DueDateRuleUpdateRequest;usedatadog_api_client::datadogV2::model::DueDateSeverity;usedatadog_api_client::datadogV2::model::SecurityFindingType;#[tokio::main]asyncfnmain(){// there is a valid "valid_due_date_rule" in the system
letvalid_due_date_rule_data_id=uuid::Uuid::parse_str(&std::env::var("VALID_DUE_DATE_RULE_DATA_ID").unwrap()).expect("Invalid UUID");letbody=DueDateRuleUpdateRequest::new(DueDateRuleDataCreate::new(DueDateRuleAttributesCreate::new(DueDateRuleAction::new(vec![DueDatePerSeverityItem::new(14,DueDateSeverity::CRITICAL)],DueDateFrom::FIRST_SEEN,),"Example-Security-Monitoring".to_string(),AutomationRuleScope::new(vec![SecurityFindingType::MISCONFIGURATION]).query("env:staging".to_string()),).enabled(false),DueDateRuleType::DUE_DATE_RULES,));letmutconfiguration=datadog::Configuration::new();configuration.set_unstable_operation_enabled("v2.UpdateSecurityFindingsAutomationDueDateRule",true);letapi=SecurityMonitoringAPI::with_config(configuration);letresp=api.update_security_findings_automation_due_date_rule(valid_due_date_rule_data_id.clone(),body,).await;ifletOk(value)=resp{println!("{:#?}",value);}else{println!("{:#?}",resp.unwrap_err());}}
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com"DD_API_KEY="<DD_API_KEY>"DD_APP_KEY="<DD_APP_KEY>"cargo run
/**
* Update a due date rule returns "Successfully updated the due date rule" response
*/import{client,v2}from"@datadog/datadog-api-client";constconfiguration=client.createConfiguration({authMethods:{AuthZ:{accessToken: process.env.DD_BEARER_TOKENasstring,},},});configuration.unstableOperations["v2.updateSecurityFindingsAutomationDueDateRule"]=true;constapiInstance=newv2.SecurityMonitoringApi(configuration);// there is a valid "valid_due_date_rule" in the system
constVALID_DUE_DATE_RULE_DATA_ID=process.env.VALID_DUE_DATE_RULE_DATA_IDasstring;constparams: v2.SecurityMonitoringApiUpdateSecurityFindingsAutomationDueDateRuleRequest={body:{data:{attributes:{action:{dueDaysPerSeverity:[{dueInDays: 14,severity:"critical",},],dueFrom:"first_seen",},enabled: false,name:"Example-Security-Monitoring",rule:{findingTypes:["misconfiguration"],query:"env:staging",},},type:"due_date_rules",},},ruleId: VALID_DUE_DATE_RULE_DATA_ID,};apiInstance.updateSecurityFindingsAutomationDueDateRule(params).then((data: v2.DueDateRuleResponse)=>{console.log("API called successfully. Returned data: "+JSON.stringify(data));}).catch((error: any)=>console.error(error));
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com"DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"tsc"example.ts"
パーソナライズされたデモをリクエスト
Datadog を始める
Ask AI
AI-generated responses may be inaccurate. Verify important info.